{
Fetches all Fields, MySQL-table has, Uses MySQL

1. Init a Handle to MySQL (MySQLInit)
2. Connect to MySQL (MySQLRealConnect)
3. Create a database (MySQLCreateDb)
4. Select this database as the one to use (MySQLSelectDb)
5. Create a table (MySQLQuery)
6. List all fields from this table (down from MySQLListFields)
7. Clean up (Drop the Database and so on)
}

program fetchfield;

uses MySQL;

var 
  MHandle: PMySQL;
  MRes: PMySQLRes;
  NumFields: Cardinal;
  i: Integer;
  Field: PMySQLField;
	
begin
  MHandle := MySQLInit (MHandle);
  if MySQLRealConnect(MHandle, 'localhost', '', '', '', 0, nil, 0) = nil then
    WriteLn (' Error: MySQLRealConnect returned nil ')
  else
    begin
      Write('Create Database ''test_MySQLunit''..');
      if not MySQLCreateDb (MHandle, 'test_MySQLunit') then
        begin
          MySQLClose (MHandle);
          WriteLn ('failed!!! (Maybe exists or you don''t have the permission)');
          Halt(1)
        end;
      WriteLn ('done.');
      Write ('Select Db to ''test_MySQLunit''..');
      if not MySQLSelectDb (MHandle, 'test_MySQLunit') then
        begin
          MySQLClose (MHandle);
          WriteLn ('failed!!!');
          Halt(1)
        end;
      WriteLn ('done.');
      Write ('Create Table ''MySQLtest''..');
      if not MySQLQuery(MHandle, 
		  'CREATE TABLE MySQLtest(nr INT, firstname VARCHAR(100), lastname VARCHAR(100))') then
		    begin
		      WriteLn ('failed!!!');
		      if not MySQLDropDb (MHandle, 'test_MySQLunit') then
		        WriteLn ('Please Clean up manually');
		      MySQLClose (MHandle);
		      Halt(1)
		    end;
		  WriteLn ('done.');
		  MRes := MySQLListFields (MHandle, 'MySQLtest', nil);
		  if MRes = nil then
		    WriteLn ('Error: table `MySQLtest'' not found.')
		  else
		    begin
		      NumFields := MySQLNumFields (MRes);
		      for i := 0 to NumFields - 1 do
		        begin
		          Field := MySQLFetchField (MRes);
		          WriteLn (i, ') ', CString2String (Field^.name))
		        end;
		      MySQLFreeResult (MRes)
		    end;
      Write('Clean up..');
      
      { Clean up }
      if not MySQLDropDb (MHandle, 'test_MySQLunit') then
        WriteLn ('Can''t Drop Database! Please clean up manually')
      else
        WriteLn('done.');
      MySQLClose(MHandle)
    end	
end.
